##################################################
## CTSM-R @: www.ctsm.info
## Simulation of the state
## By Jan Kloppenborg Moller (jkmo@dtu.dk)
## Please read the README.txt file of this folder
## License: GPL v2
##################################################

PredSimFun<-function(data,fit,model){
  # calculate 1-step prediction for each data series
  # and return a data.frame
  # data: a list of data sequences
  # fit : a ctsm object
  # model: a ctsm model
  # vx0 : initial xtsate covariance matrix
  # RWstate: name of the random walk parameter
    Pred<-c()
    Sim<-c()
    for(i in 1:length(data)){
        pred<-predict(fit, newdata = data[[i]], first=TRUE)
        sim<-simulate(fit, newdata = data[[i]], first=TRUE)
        Pred<-rbind(Pred,cbind(ser=i,t=data[[i]]$t,
                               DP=data[[i]]$DP,
                               Q=data[[i]]$Q,
                               y=data[[i]]$y,
                               J=pred$output$pred$y,
                               I=pred$state$pred$I,
                               z=pred$state$pred$z,
                               sdJ = pred$output$sd$y,
                               sdI = pred$state$sd$I,
                               sdz =pred$state$sd$z,
                               Jsim=sim$output$sim$y,
                               Isim=sim$state$sim$I,
                               zsim=sim$state$sim$z,
                               sdJsim = sim$output$sd$y,
                               sdIsim = sim$atate$sd$I,
                               sdzsim = sim$state$sd$z))
    }
    return(data.frame(Pred))
}

SimFun<-function(data,fit,model){
    ## calculate 1-step prediction for each data series
    ## and return a data.frame
    ## data: a list of data sequences
    ## fit : a ctsm object
    ## model: a ctsm model
    ## vx0 : initial xtsate covariance matrix
    ## RWstate: name of the random walk parameter
    Sim<-c()
    for(i in 1:length(data)){
        sim<-simulate(fit, newdata = data[[i]], first=TRUE)
        Sim<-rbind(Sim,cbind(ser=i,t=data[[i]]$t,
                             DP=data[[i]]$DP,
                             Q=data[[i]]$Q,
                             y=data[[i]]$y,
                             Jsim=sim$output$sim$y,
                             Isim=sim$state$sim$I,
                             zsim=sim$state$sim$z,
                             sdJsim = sim$output$sd$y,
                             sdIsim = sim$atate$sd$I,
                             sdzsim = sim$state$sd$z))
    }
    names(Sim)<-c("ser","t","DP","Q","J","I","z","sdJ","sdI","sdz")
    return(data.frame(Sim))
}
